#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
		ofSetVerticalSync(true);
		ofSetFrameRate(60);
	
	coolImg.loadImage("sperm.png");
	coolImg.resize(20, 20);
	coolImg.setImageType(OF_IMAGE_COLOR_ALPHA);
	
	
	coolImg2.loadImage("jolie.jpg");
	coolImg2.resize(40, 40);
	coolImg2.setImageType(OF_IMAGE_COLOR_ALPHA);
	

	
	for (int i = 0; i < 100; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		//particles.push_back(myParticle);
		myParticle.myImage = &coolImg;
		particles.push_back(myParticle);
	}
		
	

	
	
	/*for (int i = 0; i < 1000; i++){
		particle myParticle;
		float vx = ofRandom(-4,4);
		float vy = ofRandom(-4,4);
		myParticle.setInitialCondition(300,300,vx, vy);
		myParticle.myImage = & coolImg;
		// more interesting with diversity :)
		// uncomment this: 
		//myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
	}*/
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].resetForce();
	}
	
	
	int count = 0;

	for (int i = 0; i < particles.size(); i++){
		
			particles[i].addAttractionForce(mouseX, mouseY, 1000, 0.09f);
		
		for (int j = 0; j < i; j++){
			count++;
			particles[i].addAttractionForce(particles[j], 200, 0.1);
			particles[i].addRepulsionForce(particles[j], 100, 0.3);
			
		}
	}

	for (int i = 0; i < particles.size(); i++){
		
		particles[i].xenoToPoint(mouseX, mouseY);
	}
	
	printf("doing %i calculations \n", count);
	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].addDampingForce();
		particles[i].update();
	}
	

	
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	
//	ofEnableAlphaBlending();
//	ofSetColor(0,130,130, 200);
	
//	ofSetColor(0x000000);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	
	
	coolImg2.draw(mouseX,mouseY);
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	

	particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(x,y,0,0);
	myParticle.myImage = &coolImg;
	particles.push_back(myParticle);
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
